
program lloyd

  use sep
  use lloyd_mod

  implicit none

  real, allocatable :: attr(:,:),junk(:,:),scales(:)
  real :: dx,dy,dz,ox,oy,oz
  integer,allocatable :: iregion(:),nstart(:)
  integer :: nref,i,iref,izs,ia,ib,imap,nx,ny,nz,npar,ntotal
  logical :: vel_map

  call sep_init()

  call from_param("nref",nref,20)
  call from_param("vel_map",vel_map,.false.)
  call init_lloyd();

  call from_history("n1",nx)
  call from_history("n2",ny)
  call from_history("n3",nz)
  call from_history("n4",npar)
  call from_history("d1",dx) 
  call from_history("d2",dy)
  call from_history("d3",dz)
  call from_history("o1",ox)
  call from_history("o2",oy)
  call from_history("o3",oz)
 
  allocate(scales(npar),nstart(npar))
  call from_param("nstart",nstart)
  call from_param("scales",scales) !product(nstart) < nref

  if(vel_map) then
  call to_history("n1",nx)
  call to_history("n2",ny)
  call to_history("n3",nz)
  call to_history("n4",npar)
  call to_history("d1",dx) 
  call to_history("d2",dy)
  call to_history("d3",dz)
  call to_history("d4",1.)
  call to_history("o1",ox)
  call to_history("o2",oy)
  call to_history("o3",oz)
  call to_history("o4",0.) 
   
  call to_history("n1",nx,"region")
  call to_history("n2",ny,"region")
  call to_history("n3",nz,"region")
  call to_history("d1",dx,"region") 
  call to_history("d2",dy,"region")
  call to_history("d3",dz,"region")
  call to_history("o1",ox,"region")
  call to_history("o2",oy,"region")
  call to_history("o3",oz,"region")

  call to_history("n1",nref,"attr")
  call to_history("n2",npar,"attr")
  call to_history("d1",1.,"attr") 
  call to_history("d2",1.,"attr")
  call to_history("o1",1.,"attr")
  call to_history("o2",1.,"attr")
  else
    call to_history("n2",npar)
    call to_history("n1",nref)
  end if

  allocate(iregion(nx*ny*nz),junk(nx*ny*nz,npar),attr(nref,npar))

  ntotal=0
  call sep_read(junk)

   do i=1,npar
     junk(:,i)=junk(:,i)*scales(i)
   end do

   iref= lloyd_go(junk,attr,nref,iregion,nstart)
   ntotal=ntotal+iref

   do i=1,npar
     junk(:,i)=junk(:,i)/scales(i)
     attr(:,i)=attr(:,i)/scales(i)
   end do

   if(vel_map) then
     do ib=1,size(junk,1)
       junk(ib,:)=attr(iregion(ib),:)
     end do
     call sep_write(junk)
     call sep_write(real(iregion),"region")
     call sep_write(attr,"attr")
   else
     if(iref < nref) then
       attr(iref+1:,:)=-1
     end if
     call sep_write(attr)
   end if

  write(0,*)"*******************************"
  write(0,*)"      NTOTAL = ", ntotal
  write(0,*)"*******************************"

 call sep_close()

end program
