program make_filter

  use filter_mod
  use sep

  implicit none
  
  integer :: nx,ny,nz,filter_length,ifx,ify,ifz,ikxdx,ikydy,ikzdz,mode,exact
  real :: eps1,eps2,del1,del2,del3,vpz,dx,dy,dz,ox,oy,oz,dt,dkxdx,kxdx,kydy,kzdz
  real :: Amax,Amin,Bmax,Bmin,lambda_max(2),lambda_min(2),temp,kdmax(3),kdmin(3)

  call sep_init()

  call from_param("filter_length",filter_length)
  call from_param("mode",mode)
  call from_param("exact",exact)

  call from_param("n1",nx)
  call from_param("n2",ny)
  call from_param("n3",nz)
  call from_param("d1",dx) !dispersion dx = vmin/fmax/3.5
  call from_param("d2",dy)
  call from_param("d3",dz)
  call from_param("o1",ox)
  call from_param("o2",oy)
  call from_param("o3",oz)

  call init_space(ox,oy,oz,dx,dy,dz,nx,ny,nz)

  call from_param("filter_length",filter_length)

  call from_param("eps1",eps1)
  call from_param("eps2",eps2)
  call from_param("del1",del1)
  call from_param("del2",del2)
  call from_param("del3",del3)
  call from_param("vpz",vpz)  
  write(0,*) "here1"
  call init_vel(eps1,eps2,del1,del2,del3,vpz)
  write(0,*) "here2"
  call init_filter(filter_length,mode,exact)
  write(0,*) "here3"
  call write_filter()
  write(0,*) "here4"
  call to_history("n1",nx)
  call to_history("n2",ny)
  call to_history("n3",nz)
  call to_history("o1",0)
  call to_history("o2",0)
  call to_history("o3",0)
  call to_history("d1",1)
  call to_history("d2",1)
  call to_history("d3",1)

  call sep_write(ufilter)

  call sep_close()

end program
