program wedgeInVoZ

  use sep

  implicit none

  real,allocatable :: v(:,:,:)
  real :: ox,oy,oz,dx,dy,dz,vmax,vmin,vwedge
  integer :: nx,ny,nz,ix,iy,iz,halfx,halfz

  call sep_init()

  call from_param("n1",nx)
  call from_param("n2",ny)
  call from_param("n3",nz)
  call from_param("d1",dx) 
  call from_param("d2",dy)
  call from_param("d3",dz)
  call from_param("o1",ox)
  call from_param("o2",oy)
  call from_param("o3",oz)

  call from_param("vmax",vmax)
  call from_param("vmin",vmin)
  call from_param("vwedge",vwedge)

  allocate(v(nx,ny,nz))
  do iz=1,nz
    v(:,:,iz) = vmin + (vmax-vmin)/(nz-1.)*(iz-1)
  enddo

  halfx = (nx-1)/2
  halfz = (nz-1)/2

  do iy=1,ny
    do ix=halfx,nx
      do iz=1,nz
        if ((ix-halfx) >= abs(iz-halfz)) v(ix,iy,iz)=vwedge
      enddo
    enddo
  enddo

  call to_history("n1",nx)
  call to_history("n2",ny)
  call to_history("n3",nz)
  call to_history("d1",dx) 
  call to_history("d2",dy)
  call to_history("d3",dz)
  call to_history("o1",ox)
  call to_history("o2",oy)
  call to_history("o3",oz)

  call sep_write(v)
  deallocate(v)
  call sep_close()
 
end program
